#pragma once
namespace Util {

//---------------------------------------------------------------------------------//
// ppMsg: vLocalFree
//---------------------------------------------------------------------------------//
BOOL FindFormatMessage(DWORD dwMessageId , const CStringArray& strDlls, OUT LPTSTR* ppMsg);

//---------------------------------------------------------------------------------//
// dll list dialog
//---------------------------------------------------------------------------------//
BOOL DllListDlg(CWnd* pParent, IN OUT CStringArray& strDlls);

//---------------------------------------------------------------------------------//
// msg search dialog
//---------------------------------------------------------------------------------//
struct MsgDlgParam
{
	HWND	hwndErrList;
	CString	strMsg;
	int		nSearch;
};
BOOL MsgSearchDlg(CWnd* pParent, MsgDlgParam& mdp);// xłsꂽƂATRUE

//---------------------------------------------------------------------------------//
// 
//---------------------------------------------------------------------------------//
BOOL SetClipboardText(HWND hwnd, LPCTSTR psz);
LPTSTR StrRemove(LPTSTR psz, LPCTSTR pszRemove);


// ----------------------------------------------------------------------------------
// LVItemCompare
//
struct LVItemCompare
{
	PFNLVCOMPARE    m_pfnCompare;
	BOOL            m_bAscending;
	LPARAM          m_lParamSort;
	LVItemCompare(PFNLVCOMPARE pfn, BOOL bAscending, LPARAM lParamSort = 0) : 
		m_pfnCompare(pfn), m_bAscending(bAscending), m_lParamSort(lParamSort)
	{ }
	int Compare(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
	{
		ASSERT(m_pfnCompare);
		int iRet = (*m_pfnCompare)(lParam1, lParam2, lParamSort);
		return (m_bAscending ? iRet : -1*iRet);
	}
	static int CALLBACK ComparePrimary(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
	{
		LVItemCompare* compare = reinterpret_cast<LVItemCompare*>(lParamSort);
		return compare->Compare(lParam1, lParam2, compare->m_lParamSort);
	}
};

// ----------------------------------------------------------------------------------
// StrToken
//
struct StrToken
{
   LPTSTR  m_pszTokNext;
   StrToken(LPTSTR pszStr) : m_pszTokNext(pszStr)
   { }
   LPTSTR operator()(LPCTSTR pszDelimit)
   {
       if(! m_pszTokNext)
       {
           return NULL;
       }
       LPTSTR  pszTok = m_pszTokNext;
       LPTSTR  psz = StrPBrk(m_pszTokNext, pszDelimit);
       if(! psz)
       {
           m_pszTokNext = NULL;
       }
       else
       {
           *psz = '\0';
           m_pszTokNext = psz+1;
       }
       return pszTok;
   }
};

}		// namespace Util
